<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="utf-8">
<meta name="generator" content="https://txt2tags.org">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Open+Sans&display=swap">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Oswald:400,700">
<link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Montserrat">
<link rel="stylesheet" href="https://www.dicas-l.com.br/css/responsee.css">
<link rel="stylesheet" href="../style/extra.css">
<style>
blockquote{margin: 1em 2em; border-left: 2px solid #999;
  font-style: oblique; padding-left: 1em;}
blockquote:first-letter{margin: .2em .1em .1em 0; font-size: 160%; font-weight: bold;}
blockquote:first-line{font-weight: bold;}
body{font-family: sans-serif;}
hr{background-color:#000;border:0;color:#000;}
hr.heavy{height:2px;}
hr.light{height:1px;}
img{border:0;display:block;}
img.right{margin:0 0 0 auto;}
img.center{border:0;margin:0 auto;}
table{border-collapse: collapse;}
table th,table td{padding: 3px 7px 2px 7px;}
table th{background-color: lightgrey;}
table.center{margin-left:auto; margin-right:auto;}
.center{text-align:center;}
.right{text-align:right;}
.left{text-align:left;}
.tableborder,.tableborder td,.tableborder th{border:1px solid #000;}
.underline{text-decoration:underline;}
</style>
</head>
<body>
<header>
<hgroup>
</hgroup>
</header>


<div class="body">

<section>
<h1>O bc do Linux e o bc do BSD</h1>

<p>
Se você usa Linux, é bem provável que já tenha tido contato com o comando <code>bc</code>. Ele é a forma mais tradicional para trabalhar com matemática quando se precisa mais que a aritmética com valores inteiros do <code>bash</code> mas ainda não é necessário adentrar o domínio das aplicações de CAS (Computer Algebra System).
</p>
<p>
As distribuições Linux adotam por padrão o <a href="http://gnu.org/software/bc">GNU bc</a>, mas existe pelo menos um outro “sabor” dele rolando por aí… É o bc do <a href="http://gavinhoward.com/about">Gavin Howard</a>, um <a href="http://git.yzena.com/gavin/bc">fork</a> do GNU bc com <a href="http://git.yzena.com/gavin/bc#comparison-to-gnu-bc">algumas características interessantes e outras tantas otimizações</a>. Segundo a página do projeto:
</p>

<pre class="comandos">
<span class="saida">This is an implementation of the POSIX bc calculator that implements</span>
<span class="saida">GNU bc extensions, as well as the period (.) extension for the BSD</span>
<span class="saida">flavor of bc.</span>
</pre>

<p>
Ele vem sendo adotado por padrão no FreeBSD, por exemplo. Dificilmente chegará a ocupar o lugar do GNU bc nas distribuições Linux mas, ainda que não apareça tão cedo um repositório ou mesmo um pacote de pronta instalação, a <a href="http://git.yzena.com/gavin/bc#build">compilação</a> do <a href="http://git.yzena.com/gavin/bc/releases/latest">código fonte</a> é bastante simples e rápida.
</p>
<p>
Aqui eu gostaria de salientar especificamente algumas semelhanças e diferenças entre as duas versões.
</p>
<p>
Nos exemplos abaixo, o caminho do GNU bc, instalado a partir dos repositórios do Ubuntu, é <code>/usr/bin/bc</code>, enquanto o caminho do bc do Gavin, instalado a partir da compilação do código fonte, é <code>/usr/local/bin/bc</code>.
</p>

<hr class="light">

<p>
No GNU bc os valores de saída são quebrados a cada 68 dígitos (incluindo o eventual ponto decimal). Essa característica pode ser customizada setando a posição de quebra na variável <code>BC_LINE_LENGTH</code>, mas o valor deve incluir a contra barra e a nova linha na contagem. É preciso setar a variável para zero para que as linhas sejam devolvidas inteiras. Outra particularidade dessa versão é que números maiores que <code>-1</code> e menores que <code>1</code> não apresentam zero cabide:
</p>

<pre class="comandos">
$ /usr/bin/bc --version
<span class="saida">bc 1.07.1</span>
<span class="saida">Copyright 1991-1994, 1997, 1998, 2000, 2004, 2006, 2008, 2012-2017 Free Software Foundation, Inc.</span>

$ /usr/bin/bc &lt;&lt;&lt; 'scale=300; 1/2888'
<span class="saida">.0003462603878116343490304709141274238227146814404432132963988919667\</span>
<span class="saida">59002770083102493074792243767313019390581717451523545706371191135734\</span>
<span class="saida">07202216066481994459833795013850415512465373961218836565096952908587\</span>
<span class="saida">25761772853185595567867036011080332409972299168975069252077562326869\</span>
<span class="saida">80609418282548476454293628808</span>

$ BC_LINE_LENGTH=50 /usr/bin/bc &lt;&lt;&lt; 'scale=300; 1/2888'
<span class="saida">.00034626038781163434903047091412742382271468144\</span>
<span class="saida">044321329639889196675900277008310249307479224376\</span>
<span class="saida">731301939058171745152354570637119113573407202216\</span>
<span class="saida">066481994459833795013850415512465373961218836565\</span>
<span class="saida">096952908587257617728531855955678670360110803324\</span>
<span class="saida">099722991689750692520775623268698060941828254847\</span>
<span class="saida">6454293628808</span>

$ BC_LINE_LENGTH=0 /usr/bin/bc &lt;&lt;&lt; 'scale=300; 1/2888'
<span class="saida">.000346260387811634349030470914127423822714681440443213296398891966759002770083102493074792243767313019390581717451523545706371191135734072022160664819944598337950138504155124653739612188365650969529085872576177285318559556786703601108033240997229916897506925207756232686980609418282548476454293628808</span>
</pre>

<p>
A versão de Gavin também faz uso da variável <code>BC_LINE_LENGTH</code> mas, conforme <a href="http://git.yzena.com/gavin/bc/src/branch/master/NEWS.md#5-1-0">documentado no changelog</a>, se o desejo for uma linha de saída sem quebras, essa opção e o zero cabide são características controláveis por parâmetros: <code>-L</code> desativa a quebra de linha e <code>-z</code> apresenta números entre <code>-1</code> e <code>1</code> com um zero à esquerda do ponto decimal:
</p>

<pre class="comandos">
$ /usr/local/bin/bc --version
<span class="saida">bc 6.6.0</span>
<span class="saida">Copyright (c) 2018-2023 Gavin D. Howard and contributors</span>
<span class="saida">Report bugs at: https://git.gavinhoward.com/gavin/bc</span>

<span class="saida">This is free software with ABSOLUTELY NO WARRANTY.</span>

$ /usr/local/bin/bc &lt;&lt;&lt; 'scale=300; 1/2888'
<span class="saida">.0003462603878116343490304709141274238227146814404432132963988919667\</span>
<span class="saida">59002770083102493074792243767313019390581717451523545706371191135734\</span>
<span class="saida">07202216066481994459833795013850415512465373961218836565096952908587\</span>
<span class="saida">25761772853185595567867036011080332409972299168975069252077562326869\</span>
<span class="saida">80609418282548476454293628808</span>

$ /usr/local/bin/bc -zL &lt;&lt;&lt; 'scale=300; 1/2888'
<span class="saida">0.000346260387811634349030470914127423822714681440443213296398891966759002770083102493074792243767313019390581717451523545706371191135734072022160664819944598337950138504155124653739612188365650969529085872576177285318559556786703601108033240997229916897506925207756232686980609418282548476454293628808</span>
</pre>

<p>
Também, diferentemente do equivalente GNU, suporta internacionalização:
</p>

<pre class="comandos">
$ LC_MESSAGES=pt_BR.utf8 /usr/bin/bc &lt;&lt;&lt; 1/0
<span class="saida">Runtime error (func=(main), adr=3): Divide by zero</span>

$ LC_MESSAGES=pt_BR.utf8 /usr/local/bin/bc &lt;&lt;&lt; 1/0
<span class="saida">Erro de cálculo: dividir por 0</span>
<span class="saida">    Função: (main)</span>
</pre>

<p>
Infelizmente parece que, pelo menos por enquanto e semelhantemente ao equivalente GNU, ignora o valor de <code>LC_NUMERIC</code> e portanto não “trabalha” nativamente com a vírgula como separador decimal e o ponto como separador de milhar em locales latinos como <code>pt_BR</code>, exigindo alguma técnica complementar para isso:
</p>

<pre class="comandos">
$ LC_ALL= LC_NUMERIC=pt_BR.utf8 /usr/local/bin/bc &lt;&lt;&lt; 'scale=10; 10^4*22/7'
<span class="saida">31428.571428</span>
</pre>

<p>
O comando <code>printf</code>, por exemplo, honra o formato numérico associado ao locale:
</p>

<pre class="comandos">
$ LC_ALL= LC_NUMERIC=en_US.utf8 printf "%'012.4f\n" 31428.571428
<span class="saida">031,428.5714</span>

$ LC_ALL= LC_NUMERIC=pt_BR.utf8 printf "%'012.4f\n" 31428.571428
<span class="saida">-bash: printf: 31428.571428: número inválido</span>
<span class="saida">031.428,0000</span>

$ LC_ALL= LC_NUMERIC=pt_BR.utf8 printf "%'012.4f\n" 31428,571428
<span class="saida">031.428,5714</span>
</pre>

<p>
Portanto é ideal para driblar essa deficiência, bastando usá-lo com o resultado dos <code>bc</code>’s:
</p>

<pre class="comandos">
$ val=$(/usr/local/bin/bc &lt;&lt;&lt; 'scale=10; 10^4*22/7')
$ echo $val
<span class="saida">31428.5714285714</span>
$ echo ${val/./,}
<span class="saida">31428,5714285714</span>

$ LC_ALL= LC_NUMERIC=pt_BR.utf8 printf -v val "%'012.4f\n" ${val/./,}
$ echo $val
<span class="saida">031.428,5714</span>
</pre>

<p>
Outras alternativas para formatar a saída do <code>bc</code> incluem o (gnu) <code>sed</code>, o (gnu) <code>awk</code> e o comando <code>numfmt</code>. Não sendo built-ins do <code>bash</code> como o <code>printf</code>, são sensivelmente mais lentos, mas cada um possui características suficientemente interessantes para que, dependendo da situação, seu uso se justifique.
</p>

<section>
<h2>Comandos mencionados nesse artigo</h2>

 <ul>
 <li><a href="http://manpages.debian.org/bullseye/bash/bash.1.en.html">bash</a>
 </li>
 <li><a href="http://manpages.debian.org/bullseye/bc/bc.1.en.html">gnu bc</a>
 </li>
 <li><a href="http://freebsd.org/cgi/man.cgi?query=bc">bc</a>
 </li>
 <li><a href="http://manpages.debian.org/bullseye/sed/sed.1.en.html">gnu sed</a>
 </li>
 <li><a href="http://freebsd.org/cgi/man.cgi?query=sed">sed</a>
 </li>
 <li><a href="http://manpages.debian.org/bullseye/gawk/gawk.1.en.html">gnu awk</a>
 </li>
 <li><a href="http://freebsd.org/cgi/man.cgi?query=awk">awk</a>
 </li>
 <li><a href="http://manpages.debian.org/bullseye/bash/bash.1.en.html#printf">printf</a>
 </li>
 <li><a href="http://manpages.debian.org/bullseye/coreutils/numfmt.1.en.html">numfmt</a>
 </li>
 </ul>

</section>
</section>
</div>
</body></html>
